// JUSTCHLD.CPP
// used only by being included into "REPORTER.CPP".

// Note: the MDI menus need to be taken care of by you!

extern "C" LRESULT CALLBACK _export CRPEChildWndProc(HWND,UINT,WPARAM,LPARAM);

HWND HReporter::WindowAttr::CreateMDIChild (HWND hClient,LPSTR title) {
	WNDCLASS wc;
	HINSTANCE hInst = (HINSTANCE)::GetWindowWord(hClient,GWW_HINSTANCE);
	// Register the MDI child window.
	if (!::GetClassInfo(hInst, HCRPEChildClassName, &wc)) { // not registered
		wc.style         = 0;
		wc.lpfnWndProc   = ::CRPEChildWndProc;
		wc.cbClsExtra    = 0;
		wc.cbWndExtra    = sizeof (HWND*);
		wc.hInstance     = hInst;
		wc.hIcon         = 0;
		wc.hCursor       = 0;
		wc.hbrBackground = 0;
		wc.lpszMenuName  = 0;
		wc.lpszClassName = HCRPEChildClassName;
		if (!::RegisterClass(&wc)) return 0;
	}
	// Create the MDI child window.
	MDICREATESTRUCT mdics;
	mdics.szClass	= HCRPEChildClassName;
	mdics.szTitle	= Title(title);
	mdics.hOwner	= hInst;
	mdics.x         = CW_USEDEFAULT;
	mdics.y         = CW_USEDEFAULT;
	mdics.cx        = CW_USEDEFAULT;
	mdics.cy        = CW_USEDEFAULT;
	mdics.style		= 0;
	mdics.lParam	= (LONG)&hWindow;
	return (HWND)::SendMessage(hClient,WM_MDICREATE,0,(LPARAM)&mdics);
}

LRESULT CALLBACK _export CRPEChildWndProc(HWND hW,UINT msg,WPARAM wp,LPARAM lp) {
	HWND* pW;
	PAINTSTRUCT ps;
	switch (msg) {
	case WM_CREATE:
		::SetWindowLong(hW,0,
			((MDICREATESTRUCT*)((CREATESTRUCT*)lp)->lpCreateParams)->lParam);
		break;
	case WM_PAINT:
		BeginPaint(hW,&ps);
		Rectangle(ps.hdc,ps.rcPaint.left,ps.rcPaint.top,ps.rcPaint.right,ps.rcPaint.bottom);
		EndPaint(hW,&ps);
		break;
	case WM_SIZE:
		pW = (HWND*)::GetWindowLong(hW,0);
		if (*pW) ::MoveWindow(*pW,0,0,LOWORD(lp),HIWORD(lp),1);
		// fall through ..
	default:
		return ::DefMDIChildProc(hW,msg,wp,lp);
	}
	return 0;
}
