// OWLMDI.CPP
//
//

#include <owl\owlpch.h>
#include <owl\applicat.h>
#include <owl\mdi.h>
#include <owl\mdichild.h>
#include <owl\dialog.h>
#include "reporter.h"

#define CM_MDIVIEW	1
#define CM_DLGVIEW	2

class TMyMDIFrame : public TMDIFrame {
public:
	HReporter rpt;

	TMyMDIFrame(LPCSTR title, TResId menuResId) : TMDIFrame(title,menuResId){}
	void MDIView();
	void DlgView();
	DECLARE_RESPONSE_TABLE (TMyMDIFrame);
};
	DEFINE_RESPONSE_TABLE1(TMyMDIFrame, TMDIFrame)
		EV_COMMAND(CM_MDIVIEW,MDIView),
		EV_COMMAND(CM_DLGVIEW,DlgView),
	END_RESPONSE_TABLE;

LPSTR rptPath = "c:\\crw\\order4.rpt";	// change to your report path name

void TMyMDIFrame::MDIView() {
	rpt.OpenReport(rptPath);
	rpt.DoMDIPreview(GetClientWindow()->HWindow);
}

	class TMyDlg : public TDialog {
	public:
		TMyDlg (TWindow* parent,HReporter* _rpt) : TDialog(parent,1){rpt=_rpt;}
		DECLARE_RESPONSE_TABLE (TMyDlg);
		void CmOk ();
	private:
		HReporter* rpt;
	};
	DEFINE_RESPONSE_TABLE1(TMyDlg, TDialog)
		EV_COMMAND(IDOK,CmOk),
	END_RESPONSE_TABLE;

	void TMyDlg::CmOk () {
		rpt->OpenReport(rptPath);
		// here, we try to get the Report Title, if any --
		LPSTR title = rpt->GetReportTitle();
		if (title) MessageBox(title,"The Report Title is:");
		else MessageBox(rpt->GetErrorText(),"CRPE Error Message");
		rpt->OutputToWindow();
	}

void TMyMDIFrame::DlgView() {
	TMyDlg dlg(this,&rpt);
	dlg.Execute();
}

//----------------------------------------------------------------------------
class TMDIApp : public TApplication {
public:
	TMDIApp() : TApplication("MDI Report View") {}
	void InitMainWindow() {MainWindow=new TMyMDIFrame(GetName(),"MDIMenu");}
	HReporter rpt;
};

int OwlMain(int,char*[]) { return TMDIApp().Run(); }

